! ESA (C) 2000-2018 
!
! This file is part of ESA's XMM-Newton Scientific Analysis System (SAS).
!
!    SAS is free software: you can redistribute it and/or modify
!    it under the terms of the GNU General Public License as published by
!    the Free Software Foundation, either version 3 of the License, or
!    (at your option) any later version.
!
!    SAS is distributed in the hope that it will be useful,
!    but WITHOUT ANY WARRANTY; without even the implied warranty of
!    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
!    GNU General Public License for more details.
!
!    You should have received a copy of the GNU General Public License
!    along with SAS.  If not, see <http://www.gnu.org/licenses/>.
! Note: nagfor requires switch -f2003 to avoid warnings, g95/gfortran ok without
module catcorr_mod
use types
use errorHandling
use param
use catcorr_minor	! defined in catprep
use catcorr_aux
implicit none
! Requires command-line argument srclistset=filename for name of input OBSMLI file
! It also requires a second parameter catset=catextract which
!   specifies the name of a catalogue extract file produced by catprep task.
!
integer  :: minGood
real     :: minFit, maxOffset, syserr, maxpofferr
logical :: astcorr
character(1024) :: inOutFile, catextract	! Size defined in /param/src/param.f90
!
contains
!------------------------------------------------------------------------------
subroutine catcorr
implicit none
integer :: status	! , nfiles, mingood
status = 0
inOutFile = stringParameter('srclistset')
catextract = stringParameter('catset')
minGood    = intParameter('mingood')
minFit     = realParameter('minfit')
maxOffset  = realParameter('maxoffset')
syserr     = realParameter('syserr')
maxpofferr = realParameter('maxpofferr')
astcorr    = booleanParameter('astcorr')
!
call catcorr_top(inOutFile, catextract, mingood, minfit, maxoffset, &
                 syserr, maxpofferr, astcorr, status)
!
end subroutine catcorr

end module catcorr_mod
